# This module holds shared data about the game that other
# modules will need to access

import pygame, thing, lawn
import math

sdim = sx, sy = 800, 500
lawndim = lawnx, lawny = 800, 400
lawny0 = 100
lawncenter = lawncx, lawncy = sx/2., sy-lawny/2.
kx, ky, kz = lawnx/2., lawny/2., 260

theta = 0
C, S = 1, 0

def addtheta(n):
  global theta
  theta += n
  while theta >= 360: theta -= 360
  while theta < 0: theta += 360
  setCS()

def setCS():
  global C, S
  C = math.cos(math.radians(theta))
  S = math.sin(math.radians(theta))

# return a transformed pair of coordinates:
# internal representation to screen
def Rxy(x, y = None):
  if y == None: x,y = x
  return C*x + S*y, -S*x + C*y
# screen to internal representation
def Rtxy(x, y = None):
  if y == None: x,y = x
  return C*x - S*y, S*x + C*y

# convert untransformed coordinates to pixel coordinates:
def Pxy(x, y = None, z=0):
  if y == None: x,y = x
  nx, ny = Rxy(x, y)
  return nx*kx+lawncx, ny*ky+lawncy - z*kz
# convert pixel coordinates to untransformed coordinates:
def Ptxy(x, y = None):
  if y == None: x,y = x
  nx, ny = (x-lawncx)/kx, (y-lawncy)/ky
  return Rtxy(nx, ny)


coverage = 0
maxacorns = 3
def setcoverage():
  global coverage, maxacorns
  a = 100
  im = pygame.Surface((2*a, 2*a))
  im.fill((0, 255, 0))
  for s in thing.StarPlant.group.sprites():
    if s.isdisabled(): continue
    x, y, r = int(s.x * a) + a, int(s.y * a) + a, int(s.rstar * a)
    pygame.draw.ellipse(im, (255, 255, 0), pygame.Rect(x-r, y-r, 2*r, 2*r))
  lawn.cookiecut(im)
  s = 1
  im = pygame.transform.smoothscale(im, (s,s))
  r, g = 0., 0
  for x in range(s):
    for y in range(s):
      r += im.get_at((x,y))[0]
      g += im.get_at((x,y))[1]
  coverage = r/g
  maxacorns = 3 + int(30 * coverage)
#  return r,g,r/g


