import data, gamestate, lawn, thing, rain, cursor
import math, random, pygame

def startup():
  pygame.init()
  gamestate.screen = pygame.display.set_mode(gamestate.sdim)
  lawn.makelawn((100,50,0), (0,255,0))
  cursor.startup()

def randompos():
  x,y = 1,1
  while x**2 + y**2 >= 1:
    x = random.uniform(-1,1)
    y = random.uniform(-1,1)
  return x,y

def coverage():
  a = 100
  im = pygame.Surface((2*a, 2*a))
  im.fill((0, 255, 0))
  for s in thing.StarPlant.group.sprites():
    x, y, r = int(s.x * a) + a, int(s.y * a) + a, int(s.rstar * a)
    pygame.draw.ellipse(im, (255, 255, 0), pygame.Rect(x-r, y-r, 2*r, 2*r))
  lawn.cookiecut(im)
#  r = im.get_rect()
#  r.topright = gamestate.screen.get_rect().topright
#  gamestate.screen.blit(im, r)
  s = 1
  im = pygame.transform.smoothscale(im, (s,s))
  r, g = 0., 0
  for x in range(s):
    for y in range(s):
      r += im.get_at((x,y))[0]
      g += im.get_at((x,y))[1]
#      print r,g
  return r,g,r/g

def main():
  startup()
  clock = pygame.time.Clock()
  gamestate.done = False
  ctheta = 0
  gamestate.theta = 0
  fskip, jframe = 1, 0
  s = thing.Seeder((0,0))
#  d = [thing.Dewdrop(randompos()) for j in range(18)]
#  dd = [thing.Dewdropper(randompos()) for j in range(2)]
#  sp = [thing.StarPlant(randompos()) for j in range(2)]
#  acorn = [thing.Acorn(randompos()) for j in range(20)]
#  t = [thing.Turnip(randompos()) for j in range(12)]
#  acorn[0].nab(d[0])
#  for j in range(9):
#    d[j].nab(d[j+1])
  curs = cursor.Cursor()
  curs.makemenu()
  curs.updatemenu()
  r = rain.Rain(180)
  lightning = 0
  while not gamestate.done:
    # stuff done every frame, no matter what
    curs.update()
    thing.update()
    if random.randint(0, 1) == 0: t = thing.Twinkle(randompos())
    if not lightning and random.randint(0, 1000) == 0:
      r.strike(randompos())
    jframe += 1
    if jframe % fskip: continue

    # stuff done only on non-skipped frames
    clock.tick(30. / fskip)
    for event in pygame.event.get():
      if event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
        gamestate.done = True
      if event.type == pygame.KEYDOWN and event.key == pygame.K_BACKSLASH:
        pygame.image.save(gamestate.screen, data.filepath("screencap.png"))
      if event.type == pygame.KEYDOWN and event.key == pygame.K_f:
        for s in thing.Thing.igroup: s.fertilize()
      if event.type == pygame.KEYDOWN and event.key == pygame.K_s:
        for s in thing.Thing.igroup: s.becomestarplant()
      if event.type == pygame.KEYDOWN and event.key == pygame.K_w:
        curs.pclass = thing.StarPlant
        curs.pname = "starplant"
      if event.type == pygame.KEYDOWN and event.key == pygame.K_d:
        curs.pclass = thing.Dewdropper
        curs.pname = "dewdropper"
      if event.type == pygame.KEYDOWN and event.key == pygame.K_n:
        curs.pclass = None
      if event.type == pygame.KEYDOWN and event.key == pygame.K_h:
        for s in thing.Thing.igroup:
          s.nabnearestdrop()

    m = pygame.key.get_pressed()
    if m[pygame.K_RIGHT]:
      gamestate.addtheta(2)
    if m[pygame.K_LEFT]:
      gamestate.addtheta(-2)

    if jframe % 15 == 0: gamestate.setcoverage()

    gamestate.screen.fill(r.skycolor())
    gamestate.screen.blit(lawn.frame(int(gamestate.theta/1.)%360), (0,100))
    curs.makecoverage()
    curs.drawcoverage()
    curs.drawselector()
    thing.draw(gamestate.screen)
    curs.drawcursor()
    r.draw(gamestate.screen)
    r.drawlightning()
    curs.drawinfo()
    curs.drawmenu()
#    if jframe % 200 == 199: curs.randomizemenus()
#    if random.randint(0, 20) == 0: 
#    print coverage(), clock.get_fps()
#    for a in thing.Thing.tgroup.sprites(): a.drawpoint()
    pygame.display.flip()

